/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.SCancelForceDelPassword
 *  fire.pb.SChangeGoodLockState
 *  fire.pb.SCloseGoodLocks
 *  fire.pb.SDelPassword
 *  fire.pb.SForceDelPassword
 *  fire.pb.SForceUnlockTimeExpire
 *  fire.pb.SGetGoodLocksInfo
 *  fire.pb.SGoodUnLock
 *  fire.pb.SOpenGoodLocks
 *  fire.pb.SResetPassword
 *  fire.pb.SSetPassword
 *  fire.pb.common.SCommon
 *  fire.pb.item.ItemBase
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkdb.Procedure$Task
 *  mkdb.Transaction
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.PetInfo
 *  xbean.Properties
 *  xtable.Properties
 */
package fire.pb.tel.utils;

import fire.pb.SCancelForceDelPassword;
import fire.pb.SChangeGoodLockState;
import fire.pb.SCloseGoodLocks;
import fire.pb.SDelPassword;
import fire.pb.SForceDelPassword;
import fire.pb.SForceUnlockTimeExpire;
import fire.pb.SGetGoodLocksInfo;
import fire.pb.SGoodUnLock;
import fire.pb.SOpenGoodLocks;
import fire.pb.SResetPassword;
import fire.pb.SSetPassword;
import fire.pb.common.SCommon;
import fire.pb.item.ItemBase;
import fire.pb.main.ConfigManager;
import fire.pb.talk.MessageMgr;
import fire.pb.tel.utils.CheckCodeUtils;
import fire.pb.tel.utils.CodeBean;
import fire.pb.tel.utils.TelBindUtils;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.PetInfo;
import xtable.Properties;

public class GoodsSafeLocksUtils {
    private static final Logger GoodsSafeLocksLog = Logger.getLogger((String)"SYSTEM");
    public static final long FORCE_UNLOCK_TIME = 864000000L;
    public static final long ERROR_PASSWORD_TIME = 86400000L;
    public static Map<Long, Integer> roleId2LockStateMap = new ConcurrentHashMap<Long, Integer>();

    public static void setPassword(final long roleid, final String initpd, String repeatpd) {
        if (GoodsSafeLocksUtils.isInForceDelPassword(roleid)) {
            return;
        }
        final SSetPassword sSetPassword = new SSetPassword();
        sSetPassword.status = 0;
        boolean isTrue = GoodsSafeLocksUtils.regexPassword(initpd);
        if (!isTrue) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191024, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sSetPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",密码格式不对，应该是字母或者数字组成的4到12位");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        if (initpd == null || repeatpd == null || !initpd.equals(repeatpd)) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191025, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sSetPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",密码不一致");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    String password = prop.getPassword();
                    if (!"".equals(password)) {
                        StringBuilder sbd = new StringBuilder();
                        sbd.append("role=").append(roleid).append(",密码已经设置了");
                        GoodsSafeLocksLog.error((Object)sbd.toString());
                        Procedure.psendWhileCommit((long)roleid, (Protocol)sSetPassword);
                        return false;
                    }
                    prop.setPassword(initpd);
                    prop.setIsopensafelock(1);
                    sSetPassword.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sSetPassword);
                }
                return true;
            }
        }.submit();
    }

    private static boolean regexPassword(String password) {
        if (GoodsSafeLocksUtils.StrNULL(password)) {
            return false;
        }
        Pattern pattern = Pattern.compile("^[a-zA-Z0-9]{4,12}$");
        Matcher matcher = pattern.matcher(password);
        return matcher.find();
    }

    private static boolean StrNULL(String str) {
        return str == null || str.equals("");
    }

    public static void reSetPassword(final long roleid, final String initpd, final String newtpd, String repeatpd) {
        if (GoodsSafeLocksUtils.isInForceDelPassword(roleid)) {
            return;
        }
        final SResetPassword sResetPassword = new SResetPassword();
        sResetPassword.status = 0;
        boolean isTrue = GoodsSafeLocksUtils.regexPassword(newtpd);
        if (!isTrue) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191024, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sResetPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",重新设置新密码格式不对，应该是字母或者数字组成的4到12位");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        if (newtpd == null || repeatpd == null || !newtpd.equals(repeatpd)) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191025, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sResetPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",密码不一致");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        if (initpd.equals(newtpd)) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191043, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sResetPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",新密码与原密码不可一致");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        new Procedure(){

            protected boolean process() throws Exception {
                boolean isTrue;
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null && (isTrue = GoodsSafeLocksUtils.checkPassword(roleid, initpd, (Protocol)sResetPassword, prop))) {
                    prop.setPassword(newtpd);
                    prop.setIsopensafelock(1);
                    sResetPassword.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sResetPassword);
                }
                return true;
            }
        }.submit();
    }

    public static void autoOpenGoodLocks(long roleid) {
        xbean.Properties prop = Properties.get((Long)roleid);
        if (prop != null) {
            long forcedelendtime = prop.getForcedelendtime();
            if (System.currentTimeMillis() - forcedelendtime < 0L) {
                return;
            }
            System.out.println(prop.getIsopensafelock());
            String password = prop.getPassword();
            if (password == null || "".equals(password) || prop.getIsopensafelock() == 1) {
                return;
            }
            SOpenGoodLocks sOpenGoodLocks = new SOpenGoodLocks();
            prop.setIsopensafelock(1);
            sOpenGoodLocks.status = 1;
            Procedure.psendWhileCommit((long)roleid, (Protocol)sOpenGoodLocks);
        }
    }

    public static void openGoodLocks(final long roleid) {
        if (GoodsSafeLocksUtils.isInForceDelPassword(roleid)) {
            return;
        }
        final SOpenGoodLocks sOpenGoodLocks = new SOpenGoodLocks();
        sOpenGoodLocks.status = 0;
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    String password = prop.getPassword();
                    if (password == null || "".equals(password)) {
                        MessageMgr.sendMsgNotify((long)roleid, (int)191029, null);
                        Procedure.psendWhileCommit((long)roleid, (Protocol)sOpenGoodLocks);
                        StringBuilder sbd = new StringBuilder();
                        sbd.append("role=").append(roleid).append(",你还没有设置密码，不能开始安全模式");
                        GoodsSafeLocksLog.error((Object)sbd.toString());
                        return false;
                    }
                    prop.setIsopensafelock(1);
                    sOpenGoodLocks.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sOpenGoodLocks);
                }
                return true;
            }
        }.submit();
    }

    public static void closeGoodLocks(final long roleid, final String password, byte closetype) {
        if (GoodsSafeLocksUtils.isInForceDelPassword(roleid)) {
            return;
        }
        final SCloseGoodLocks sCloseGoodLocks = new SCloseGoodLocks();
        sCloseGoodLocks.status = 0;
        sCloseGoodLocks.closetype = closetype;
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    String oldPassword = prop.getPassword();
                    if (oldPassword == null || password == null || !oldPassword.equals(password)) {
                        MessageMgr.sendMsgNotify((long)roleid, (int)191026, null);
                        StringBuilder sbd = new StringBuilder();
                        sbd.append("role=").append(roleid).append(",密码输入不对，不能关闭安全锁定模式");
                        GoodsSafeLocksLog.error((Object)sbd.toString());
                        Procedure.psendWhileCommit((long)roleid, (Protocol)sCloseGoodLocks);
                        return false;
                    }
                    prop.setIsopensafelock(0);
                    sCloseGoodLocks.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sCloseGoodLocks);
                }
                return true;
            }
        }.submit();
    }

    public static void unSafelock(final long roleid, final String initpd, String repeatpd) {
        if (GoodsSafeLocksUtils.isInForceDelPassword(roleid)) {
            return;
        }
        final SDelPassword cDelPassword = new SDelPassword();
        cDelPassword.status = 0;
        if (initpd == null || repeatpd == null || !initpd.equals(repeatpd)) {
            MessageMgr.sendMsgNotify((long)roleid, (int)191025, null);
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)cDelPassword);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleid).append(",密码不一致");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return;
        }
        new Procedure(){

            protected boolean process() throws Exception {
                boolean isTrue;
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null && (isTrue = GoodsSafeLocksUtils.checkPassword(roleid, initpd, (Protocol)cDelPassword, prop))) {
                    prop.setPassword("");
                    cDelPassword.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)cDelPassword);
                }
                return true;
            }
        }.submit();
    }

    public static void cancelForceUnSafelock(final long roleid) {
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    SCancelForceDelPassword sCancelForceDelPassword = new SCancelForceDelPassword();
                    prop.setForcedelpdtime(0L);
                    prop.setForcedelendtime(0L);
                    sCancelForceDelPassword.status = 1;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sCancelForceDelPassword);
                }
                return true;
            }
        }.submit();
    }

    public static void forceUnSafelock(final long roleid, final String code) {
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    long tel = prop.getBindtel();
                    CodeBean codeBean = null;
                    String checkCode = null;
                    if (tel > 0L) {
                        codeBean = CheckCodeUtils.getCodeBean(roleid, tel);
                        if (codeBean == null) {
                            return false;
                        }
                        checkCode = codeBean.code;
                    }
                    if (!(tel <= 0L || checkCode != null && code != null && checkCode.equals(code))) {
                        MessageMgr.sendMsgNotify((long)roleid, (int)191014, null);
                        StringBuilder sbd = new StringBuilder();
                        sbd.append("role=").append(roleid).append(",验证码不对");
                        GoodsSafeLocksLog.error((Object)sbd.toString());
                        return false;
                    }
                    long time = System.currentTimeMillis();
                    SForceDelPassword sForceDelPassword = new SForceDelPassword();
                    prop.setForcedelpdtime(time);
                    prop.setForcedelendtime(time + 864000000L);
                    sForceDelPassword.starttimepoint = time;
                    sForceDelPassword.finishtimepoint = time + 864000000L;
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sForceDelPassword);
                    TelBindUtils.clearData(roleid);
                }
                return true;
            }
        }.submit();
    }

    private static int getMaxTimesByErrorPassword() {
        SCommon conf = (SCommon)ConfigManager.getInstance().getConf(SCommon.class).get(444);
        if (conf == null) {
            GoodsSafeLocksLog.error((Object)"通用数据表数据错误，不存在编号444");
            return -1;
        }
        return Integer.parseInt(conf.getValue());
    }

    private static int getErrorPasswordLockTime() {
        SCommon conf = (SCommon)ConfigManager.getInstance().getConf(SCommon.class).get(445);
        if (conf == null) {
            GoodsSafeLocksLog.error((Object)"通用数据表数据错误，不存在编号445");
            return -1;
        }
        return Integer.parseInt(conf.getValue());
    }

    public static void getGoodLocksInfo(long roleid) {
        xbean.Properties prop = Properties.select((Long)roleid);
        if (prop != null) {
            SGetGoodLocksInfo sGetBindTel = new SGetGoodLocksInfo(prop.getPassword(), prop.getForcedelpdtime(), prop.getForcedelendtime(), (byte)(prop.getLogintimesofday() <= 1 ? 1 : 0), (byte)prop.getErrortimes(), prop.getLockendtime(), (byte)prop.getIsopensafelock());
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sGetBindTel);
        }
    }

    public static boolean isInForceDelPassword(long roleid) {
        xbean.Properties prop = Properties.select((Long)roleid);
        if (prop != null) {
            long forcedelendtime = prop.getForcedelendtime();
            if (System.currentTimeMillis() - forcedelendtime >= 0L) {
                return false;
            }
        }
        MessageMgr.sendMsgNotify((long)roleid, (int)191030, null);
        StringBuilder sbd = new StringBuilder();
        sbd.append("role=").append(roleid).append(",强制删除密码保护期内,不能做此操作");
        GoodsSafeLocksLog.error((Object)sbd.toString());
        return true;
    }

    public static void unlockGoods(final long roleId, final String password) {
        final SGoodUnLock msg = new SGoodUnLock();
        msg.status = 0;
        new Procedure(){

            protected boolean process() throws Exception {
                boolean isTrue;
                xbean.Properties prop = Properties.get((Long)roleId);
                if (prop != null && (isTrue = GoodsSafeLocksUtils.checkPassword(roleId, password, (Protocol)msg, prop))) {
                    msg.status = 1;
                    Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
                }
                return true;
            }
        }.submit();
    }

    private static boolean checkPassword(long roleId, String password, Protocol msg, xbean.Properties prop) {
        long now = System.currentTimeMillis();
        if (prop.getPassword().equals("")) {
            Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleId).append(",没有设置密码");
            GoodsSafeLocksLog.error((Object)sbd.toString());
            return false;
        }
        int maxErrorTimes = GoodsSafeLocksUtils.getMaxTimesByErrorPassword();
        if (prop.getErrortimes() >= maxErrorTimes) {
            if (now - prop.getLockendtime() <= (long)GoodsSafeLocksUtils.getErrorPasswordLockTime() * 3600000L) {
                MessageMgr.sendMsgNotify((long)roleId, (int)191027, null);
                StringBuilder sbd = new StringBuilder();
                sbd.append("role=").append(roleId).append(",您输入错误的次数已经超过5次，24小时内不可继续输入也不可进行该操作");
                GoodsSafeLocksLog.error((Object)sbd.toString());
                Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
                return false;
            }
            prop.setErrortimes(0);
        }
        if (!prop.getPassword().equals(password)) {
            int errorTimes = prop.getErrortimes() + 1;
            prop.setErrortimes(errorTimes);
            if (prop.getErrortimes() >= maxErrorTimes) {
                prop.setLockendtime(now);
                MessageMgr.sendMsgNotify((long)roleId, (int)191027, null);
                StringBuilder sbd = new StringBuilder();
                sbd.append("role=").append(roleId).append(",您输入错误的次数已经超过5次，24小时内不可继续输入也不可进行该操作");
                GoodsSafeLocksLog.error((Object)sbd.toString());
            } else {
                ArrayList<String> parameters = new ArrayList<String>();
                parameters.add(String.valueOf(maxErrorTimes - errorTimes));
                MessageMgr.sendMsgNotify((long)roleId, (int)191028, parameters);
                StringBuilder sbd = new StringBuilder();
                sbd.append("role=").append(roleId).append(",您输入错误的次数已经超过5次，24小时内不可继续输入也不可进行该操作");
                GoodsSafeLocksLog.error((Object)sbd.toString());
            }
            Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            return false;
        }
        prop.setLockendtime(0L);
        prop.setErrortimes(0);
        return true;
    }

    public static void forceUnlockTimeExpire(final long roleid) {
        new Procedure(){

            protected boolean process() throws Exception {
                xbean.Properties prop = Properties.get((Long)roleid);
                if (prop != null) {
                    long now = System.currentTimeMillis();
                    SForceUnlockTimeExpire sForceUnlockTimeExpire = new SForceUnlockTimeExpire();
                    if (now + 60000L >= prop.getForcedelendtime()) {
                        sForceUnlockTimeExpire.status = 1;
                        prop.setPassword("");
                        prop.setForcedelpdtime(0L);
                        prop.setForcedelendtime(0L);
                    } else {
                        sForceUnlockTimeExpire.status = 0;
                        GoodsSafeLocksLog.error((Object)("强制解除安全锁时间未到" + roleid));
                    }
                    Procedure.psendWhileCommit((long)roleid, (Protocol)sForceUnlockTimeExpire);
                }
                return true;
            }
        }.submit();
    }

    public static boolean checkLockStatus(long roleId, PetInfo petInfo) {
        if (petInfo.getTreasure() == 1) {
            return GoodsSafeLocksUtils.checkLockStatus(roleId);
        }
        return false;
    }

    public static boolean checkLockStatus(long roleId, ItemBase item) {
        if (item.isTreasure()) {
            return GoodsSafeLocksUtils.checkLockStatus(roleId);
        }
        return false;
    }

    public static boolean checkLockStatus(long roleId) {
        xbean.Properties prop = Properties.select((Long)roleId);
        if (prop != null) {
            if (prop.getPassword().equals("") || prop.getIsopensafelock() == 0) {
                return false;
            }
            if (roleId2LockStateMap.containsKey(roleId)) {
                return false;
            }
        }
        GoodsSafeLocksLog.error((Object)("开启了道具安全锁，需要输入密码" + roleId));
        return true;
    }

    public static void cleanDataByGoodsLock(long roleid) {
        roleId2LockStateMap.remove(roleid);
    }

    public static void doClearDataWhileCommit(long roleid) {
        if (roleId2LockStateMap.containsKey(roleid)) {
            SChangeGoodLockState sChangeGoodLockState = new SChangeGoodLockState();
            if (Transaction.current() != null) {
                Procedure.ppostWhileCommit((Procedure.Task)new LogWhileProcedureEnd(roleid));
                Procedure.psendWhileCommit((long)roleid, (Protocol)sChangeGoodLockState);
            } else {
                GoodsSafeLocksUtils.cleanDataByGoodsLock(roleid);
                Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)sChangeGoodLockState);
            }
        }
    }

    public static class LogWhileProcedureEnd
    extends Procedure.Task {
        private long roleid;

        public LogWhileProcedureEnd(long roleid) {
            this.roleid = roleid;
        }

        public void run() {
            GoodsSafeLocksUtils.cleanDataByGoodsLock(this.roleid);
        }
    }
}

